diff --git a/bisect_iv.c b/bisect_iv.c
index 09171fb..20f91a5 100644
--- a/bisect_iv.c
+++ b/bisect_iv.c
@@ -1425,7 +1425,7 @@ static int get_orig_addr(char *orig_name, char *orig_addr)
 	orig_mac = ether_aton(orig_name_tmp);
 
 	if (!orig_mac) {
-		printf("Error - the originator is not a mac address or bat-host name: %s\n", orig_name);
+		fprintf(stderr, "Error - the originator is not a mac address or bat-host name: %s\n", orig_name);
 		goto err;
 	}
 
@@ -1509,7 +1509,7 @@ int bisect_iv(int argc, char **argv)
 	}
 
 	if (argc <= found_args + 1) {
-		printf("Error - need at least 2 log files to compare\n");
+		fprintf(stderr, "Error - need at least 2 log files to compare\n");
 		bisect_iv_usage();
 		goto err;
 	}
@@ -1517,7 +1517,7 @@ int bisect_iv(int argc, char **argv)
 	node_hash = hash_new(64, compare_name, choose_name);
 
 	if (!node_hash) {
-		printf("Error - could not create node hash table\n");
+		fprintf(stderr, "Error - could not create node hash table\n");
 		goto err;
 	}
 
@@ -1525,13 +1525,13 @@ int bisect_iv(int argc, char **argv)
 	num_parsed_files = 0;
 
 	if ((rt_orig_ptr) && (trace_orig_ptr)) {
-		printf("Error - the 'print routing table' option can't be used together with the the 'trace seqno' option\n");
+		fprintf(stderr, "Error - the 'print routing table' option can't be used together with the the 'trace seqno' option\n");
 		goto err;
 	} else if ((loop_orig_ptr) && (trace_orig_ptr)) {
-		printf("Error - the 'loop detection' option can't be used together with the the 'trace seqno' option\n");
+		fprintf(stderr, "Error - the 'loop detection' option can't be used together with the the 'trace seqno' option\n");
 		goto err;
 	} else if ((loop_orig_ptr) && (rt_orig_ptr)) {
-		printf("Error - the 'loop detection' option can't be used together with the the 'print routing table' option\n");
+		fprintf(stderr, "Error - the 'loop detection' option can't be used together with the the 'print routing table' option\n");
 		goto err;
 	} else if (rt_orig_ptr) {
 		res = get_orig_addr(rt_orig_ptr, orig);
@@ -1555,7 +1555,7 @@ int bisect_iv(int argc, char **argv)
 		seqno_max = seqno_min;
 
 	if (seqno_min > seqno_max) {
-		printf("Error - the sequence range minimum (%lli) should be smaller than the maximum (%lli)\n",
+		fprintf(stderr, "Error - the sequence range minimum (%lli) should be smaller than the maximum (%lli)\n",
 		       seqno_min, seqno_max);
 		goto err;
 	}
@@ -1577,7 +1577,7 @@ int bisect_iv(int argc, char **argv)
 	}
 
 	if (num_parsed_files < 2) {
-		printf("Error - need at least 2 log files to compare\n");
+		fprintf(stderr, "Error - need at least 2 log files to compare\n");
 		goto err;
 	}
 
diff --git a/debug.c b/debug.c
index 260448b..1a3cc53 100644
--- a/debug.c
+++ b/debug.c
@@ -117,20 +117,20 @@ int handle_debug_table(char *mesh_iface, int debug_table, int argc, char **argv)
 			}
 
 			if (!sscanf(optarg, "%f", &watch_interval)) {
-				printf("Error - provided argument of '-%c' is not a number\n", optchar);
+				fprintf(stderr, "Error - provided argument of '-%c' is not a number\n", optchar);
 				return EXIT_FAILURE;
 			}
 			break;
 		case 't':
 			if (debug_table != BATCTL_TABLE_ORIGINATORS) {
-				printf("Error - unrecognised option '-%c'\n", optchar);
+				fprintf(stderr, "Error - unrecognised option '-%c'\n", optchar);
 				debug_table_usage(debug_table);
 				return EXIT_FAILURE;
 			}
 
 			read_opt |= NO_OLD_ORIGS;
 			if (!sscanf(optarg, "%f", &orig_timeout)) {
-				printf("Error - provided argument of '-%c' is not a number\n", optchar);
+				fprintf(stderr, "Error - provided argument of '-%c' is not a number\n", optchar);
 				return EXIT_FAILURE;
 			}
 			break;
@@ -139,14 +139,14 @@ int handle_debug_table(char *mesh_iface, int debug_table, int argc, char **argv)
 			break;
 		case '?':
 			if (optopt == 't')
-				printf("Error - option '-t' needs a number as argument\n");
+				fprintf(stderr, "Error - option '-t' needs a number as argument\n");
 
 			else if (optopt == 'w') {
 				read_opt |= CLR_CONT_READ;
 				break;
 			}
 			else
-				printf("Error - unrecognised option: '-%c'\n", optopt);
+				fprintf(stderr, "Error - unrecognised option: '-%c'\n", optopt);
 
 			return EXIT_FAILURE;
 		default:
@@ -157,7 +157,7 @@ int handle_debug_table(char *mesh_iface, int debug_table, int argc, char **argv)
 
 	debugfs_mnt = debugfs_mount(NULL);
 	if (!debugfs_mnt) {
-		printf("Error - can't mount or find debugfs\n");
+		fprintf(stderr, "Error - can't mount or find debugfs\n");
 		return EXIT_FAILURE;
 	}
 
@@ -197,7 +197,7 @@ int log_print(char *mesh_iface, int argc, char **argv)
 
 	debugfs_mnt = debugfs_mount(NULL);
 	if (!debugfs_mnt) {
-		printf("Error - can't mount or find debugfs\n");
+		fprintf(stderr, "Error - can't mount or find debugfs\n");
 		return EXIT_FAILURE;
 	}
 
diff --git a/debugfs.c b/debugfs.c
index 9fc6f42..bfedcfe 100644
--- a/debugfs.c
+++ b/debugfs.c
@@ -85,7 +85,7 @@ const char *debugfs_find_mountpoint(void)
 	/* give up and parse /proc/mounts */
 	fp = fopen("/proc/mounts", "r");
 	if (fp == NULL) {
-		printf("Error - can't open /proc/mounts for read: %s\n",
+		fprintf(stderr, "Error - can't open /proc/mounts for read: %s\n",
 		       strerror(errno));
 		return NULL;
 	}
diff --git a/functions.c b/functions.c
index 57c2bba..516d29f 100644
--- a/functions.c
+++ b/functions.c
@@ -130,20 +130,20 @@ static void file_open_problem_dbg(char *dir, char *fname, char *full_path)
 
 	if (strstr(dir, "/sys/")) {
 		if (stat("/sys/", &st) != 0) {
-			printf("Error - the folder '/sys/' was not found on the system\n");
-			printf("Please make sure that the sys filesystem is properly mounted\n");
+			fprintf(stderr, "Error - the folder '/sys/' was not found on the system\n");
+			fprintf(stderr, "Please make sure that the sys filesystem is properly mounted\n");
 			return;
 		}
 	}
 
 	if (!file_exists(module_ver_path)) {
-		printf("Error - batman-adv module has not been loaded\n");
+		fprintf(stderr, "Error - batman-adv module has not been loaded\n");
 		return;
 	}
 
 	if (!file_exists(dir)) {
-		printf("Error - mesh has not been enabled yet\n");
-		printf("Activate your mesh by adding interfaces to batman-adv\n");
+		fprintf(stderr, "Error - mesh has not been enabled yet\n");
+		fprintf(stderr, "Activate your mesh by adding interfaces to batman-adv\n");
 		return;
 	}
 
@@ -154,10 +154,10 @@ static void file_open_problem_dbg(char *dir, char *fname, char *full_path)
 		break;
 	}
 
-	printf("Error - can't open file '%s': %s\n", full_path, strerror(errno));
+	fprintf(stderr, "Error - can't open file '%s': %s\n", full_path, strerror(errno));
 	if (*ptr) {
-		printf("The option you called seems not to be compiled into your batman-adv kernel module.\n");
-		printf("Consult the README if you wish to learn more about compiling options into batman-adv.\n");
+		fprintf(stderr, "The option you called seems not to be compiled into your batman-adv kernel module.\n");
+		fprintf(stderr, "Consult the README if you wish to learn more about compiling options into batman-adv.\n");
 	}
 }
 
@@ -318,7 +318,7 @@ int write_file(char *dir, char *fname, char *arg1, char *arg2)
 		write_len = write(fd, arg1, strlen(arg1) + 1);
 
 	if (write_len < 0) {
-		printf("Error - can't write to file '%s': %s\n", full_path, strerror(errno));
+		fprintf(stderr, "Error - can't write to file '%s': %s\n", full_path, strerror(errno));
 		goto out;
 	}
 
diff --git a/ioctl.c b/ioctl.c
index 5056d2f..4347c20 100644
--- a/ioctl.c
+++ b/ioctl.c
@@ -50,7 +50,7 @@ static int statistics_custom_get(int fd, struct ifreq *ifr)
 	ifr->ifr_data = (caddr_t)&drvinfo;
 	err = ioctl(fd, SIOCETHTOOL, ifr);
 	if (err < 0) {
-		printf("Error - can't open driver information: %s\n", strerror(errno));
+		fprintf(stderr, "Error - can't open driver information: %s\n", strerror(errno));
 		goto out;
 	}
 
@@ -64,7 +64,7 @@ static int statistics_custom_get(int fd, struct ifreq *ifr)
 	strings = calloc(1, sz_str + sizeof(struct ethtool_gstrings));
 	stats = calloc(1, sz_stats + sizeof(struct ethtool_stats));
 	if (!strings || !stats) {
-		printf("Error - out of memory\n");
+		fprintf(stderr, "Error - out of memory\n");
 		goto out;
 	}
 
@@ -74,7 +74,7 @@ static int statistics_custom_get(int fd, struct ifreq *ifr)
 	ifr->ifr_data = (caddr_t)strings;
 	err = ioctl(fd, SIOCETHTOOL, ifr);
 	if (err < 0) {
-		printf("Error - can't get stats strings information: %s\n", strerror(errno));
+		fprintf(stderr, "Error - can't get stats strings information: %s\n", strerror(errno));
 		goto out;
 	}
 
@@ -83,7 +83,7 @@ static int statistics_custom_get(int fd, struct ifreq *ifr)
 	ifr->ifr_data = (caddr_t) stats;
 	err = ioctl(fd, SIOCETHTOOL, ifr);
 	if (err < 0) {
-		printf("Error - can't get stats information: %s\n", strerror(errno));
+		fprintf(stderr, "Error - can't get stats information: %s\n", strerror(errno));
 		goto out;
 	}
 
@@ -111,7 +111,7 @@ int ioctl_statistics_get(char *mesh_iface)
 
 	fd = socket(AF_INET, SOCK_DGRAM, 0);
 	if (fd < 0) {
-		printf("Error - can't open socket: %s\n", strerror(errno));
+		fprintf(stderr, "Error - can't open socket: %s\n", strerror(errno));
 		goto out;
 	}
 
diff --git a/main.c b/main.c
index 5d85d8b..62de857 100644
--- a/main.c
+++ b/main.c
@@ -99,7 +99,7 @@ int main(int argc, char **argv)
 
 	if ((argc > 1) && (strcmp(argv[1], "-m") == 0)) {
 		if (argc < 3) {
-			printf("Error - the option '-m' needs a parameter\n");
+			fprintf(stderr, "Error - the option '-m' needs a parameter\n");
 			goto err;
 		}
 
@@ -110,12 +110,14 @@ int main(int argc, char **argv)
 	}
 
 	if (argc < 2) {
-		printf("Error - no command specified\n");
+		fprintf(stderr, "Error - no command specified\n");
 		goto err;
 	}
 
-	if (strcmp(argv[1], "-h") == 0)
-		goto err;
+	if (strcmp(argv[1], "-h") == 0) {
+		print_usage();
+		exit(EXIT_SUCCESS);
+	}
 
 	if (strcmp(argv[1], "-v") == 0) {
 		printf("batctl %s [batman-adv: ", SOURCE_VERSION);
@@ -206,7 +208,7 @@ int main(int argc, char **argv)
 			goto out;
 		}
 
-		printf("Error - no valid command or debug table specified: %s\n", argv[1]);
+		fprintf(stderr, "Error - no valid command or debug table specified: %s\n", argv[1]);
 		print_usage();
 	}
 
diff --git a/ping.c b/ping.c
index 51d18e8..82a6744 100644
--- a/ping.c
+++ b/ping.c
@@ -124,7 +124,7 @@ int ping(char *mesh_iface, int argc, char **argv)
 	}
 
 	if (argc <= found_args) {
-		printf("Error - target mac address or bat-host name not specified\n");
+		fprintf(stderr, "Error - target mac address or bat-host name not specified\n");
 		ping_usage();
 		return EXIT_FAILURE;
 	}
@@ -140,7 +140,7 @@ int ping(char *mesh_iface, int argc, char **argv)
 		dst_mac = resolve_mac(dst_string);
 
 		if (!dst_mac) {
-			printf("Error - mac address of the ping destination could not be resolved and is not a bat-host name: %s\n", dst_string);
+			fprintf(stderr, "Error - mac address of the ping destination could not be resolved and is not a bat-host name: %s\n", dst_string);
 			goto out;
 		}
 	}
@@ -154,7 +154,7 @@ int ping(char *mesh_iface, int argc, char **argv)
 
 	debugfs_mnt = debugfs_mount(NULL);
 	if (!debugfs_mnt) {
-		printf("Error - can't mount or find debugfs\n");
+		fprintf(stderr, "Error - can't mount or find debugfs\n");
 		goto out;
 	}
 
@@ -163,7 +163,7 @@ int ping(char *mesh_iface, int argc, char **argv)
 	ping_fd = open(icmp_socket, O_RDWR);
 
 	if (ping_fd < 0) {
-		printf("Error - can't open a connection to the batman adv kernel module via the socket '%s': %s\n",
+		fprintf(stderr, "Error - can't open a connection to the batman adv kernel module via the socket '%s': %s\n",
 				icmp_socket, strerror(errno));
 		printf("Check whether the module is loaded and active.\n");
 		goto out;
@@ -203,7 +203,7 @@ int ping(char *mesh_iface, int argc, char **argv)
 		icmp_packet_out.seqno = htons(++seq_counter);
 
 		if (write(ping_fd, (char *)&icmp_packet_out, packet_len) < 0) {
-			printf("Error - can't write to batman adv kernel file '%s': %s\n", icmp_socket, strerror(errno));
+			fprintf(stderr, "Error - can't write to batman adv kernel file '%s': %s\n", icmp_socket, strerror(errno));
 			goto sleep;
 		}
 
@@ -231,7 +231,7 @@ read_packet:
 		read_len = read(ping_fd, (char *)&icmp_packet_in, packet_len);
 
 		if (read_len < 0) {
-			printf("Error - can't read from batman adv kernel file '%s': %s\n", icmp_socket, strerror(errno));
+			fprintf(stderr, "Error - can't read from batman adv kernel file '%s': %s\n", icmp_socket, strerror(errno));
 			goto sleep;
 		}
 
@@ -298,7 +298,7 @@ read_packet:
 			printf("From %s: Time to live exceeded (icmp_seq %hu)\n", dst_string, ntohs(icmp_packet_in.seqno));
 			break;
 		case BATADV_PARAMETER_PROBLEM:
-			printf("Error - the batman adv kernel module version (%d) differs from ours (%d)\n",
+			fprintf(stderr, "Error - the batman adv kernel module version (%d) differs from ours (%d)\n",
 					icmp_packet_in.header.version, BATADV_COMPAT_VERSION);
 			printf("Please make sure to use compatible versions!\n");
 			goto out;
diff --git a/sys.c b/sys.c
index e4112b7..86dd10a 100644
--- a/sys.c
+++ b/sys.c
@@ -116,21 +116,21 @@ static int print_interfaces(char *mesh_iface)
 	int res;
 
 	if (!file_exists(module_ver_path)) {
-		printf("Error - batman-adv module has not been loaded\n");
+		fprintf(stderr, "Error - batman-adv module has not been loaded\n");
 		goto err;
 	}
 
 	path_buff = malloc(PATH_BUFF_LEN);
 	if (!path_buff) {
-		printf("Error - could not allocate path buffer: out of memory ?\n");
+		fprintf(stderr, "Error - could not allocate path buffer: out of memory ?\n");
 		goto err;
 	}
 
 	iface_base_dir = opendir(SYS_IFACE_PATH);
 	if (!iface_base_dir) {
-		printf("Error - the directory '%s' could not be read: %s\n",
+		fprintf(stderr, "Error - the directory '%s' could not be read: %s\n",
 		       SYS_IFACE_PATH, strerror(errno));
-		printf("Is the batman-adv module loaded and sysfs mounted ?\n");
+		fprintf(stderr, "Is the batman-adv module loaded and sysfs mounted ?\n");
 		goto err_buff;
 	}
 
@@ -199,20 +199,20 @@ int interface(char *mesh_iface, int argc, char **argv)
 
 	if ((strcmp(argv[1], "add") != 0) && (strcmp(argv[1], "a") != 0) &&
 	    (strcmp(argv[1], "del") != 0) && (strcmp(argv[1], "d") != 0)) {
-		printf("Error - unknown argument specified: %s\n", argv[1]);
+		fprintf(stderr, "Error - unknown argument specified: %s\n", argv[1]);
 		interface_usage();
 		goto err;
 	}
 
 	if (argc == 2) {
-		printf("Error - missing interface name(s) after '%s'\n", argv[1]);
+		fprintf(stderr, "Error - missing interface name(s) after '%s'\n", argv[1]);
 		interface_usage();
 		goto err;
 	}
 
 	path_buff = malloc(PATH_BUFF_LEN);
 	if (!path_buff) {
-		printf("Error - could not allocate path buffer: out of memory ?\n");
+		fprintf(stderr, "Error - could not allocate path buffer: out of memory ?\n");
 		goto err;
 	}
 
@@ -225,16 +225,16 @@ int interface(char *mesh_iface, int argc, char **argv)
 			path_buff[PATH_BUFF_LEN - 1] = '\0';
 
 			if (!file_exists(path_buff)) {
-				printf("Error - interface does not exist: %s\n", argv[i]);
+				fprintf(stderr, "Error - interface does not exist: %s\n", argv[i]);
 				continue;
 			}
 
 			if (!file_exists(module_ver_path)) {
-				printf("Error - batman-adv module has not been loaded\n");
+				fprintf(stderr, "Error - batman-adv module has not been loaded\n");
 				goto err;
 			}
 
-			printf("Error - interface type not supported by batman-adv: %s\n", argv[i]);
+			fprintf(stderr, "Error - interface type not supported by batman-adv: %s\n", argv[i]);
 			continue;
 		}
 
@@ -404,8 +404,8 @@ int handle_sys_setting(char *mesh_iface, int setting, int argc, char **argv)
 		ptr++;
 	}
 
-	printf("Error - the supplied argument is invalid: %s\n", argv[1]);
-	printf("The following values are allowed:\n");
+	fprintf(stderr, "Error - the supplied argument is invalid: %s\n", argv[1]);
+	fprintf(stderr, "The following values are allowed:\n");
 
 	ptr = batctl_settings[setting].params;
 	while (*ptr) {
@@ -533,8 +533,8 @@ int handle_gw_setting(char *mesh_iface, int argc, char **argv)
 	goto out;
 
 opt_err:
-	printf("Error - the supplied argument is invalid: %s\n", argv[1]);
-	printf("The following values are allowed:\n");
+	fprintf(stderr, "Error - the supplied argument is invalid: %s\n", argv[1]);
+	fprintf(stderr, "The following values are allowed:\n");
 
 	ptr = sysfs_param_server;
 	while (*ptr) {
diff --git a/traceroute.c b/traceroute.c
index ac2f1fa..8eaa54f 100644
--- a/traceroute.c
+++ b/traceroute.c
@@ -86,7 +86,7 @@ int traceroute(char *mesh_iface, int argc, char **argv)
 	}
 
 	if (argc <= found_args) {
-		printf("Error - target mac address or bat-host name not specified\n");
+		fprintf(stderr, "Error - target mac address or bat-host name not specified\n");
 		traceroute_usage();
 		return EXIT_FAILURE;
 	}
@@ -102,7 +102,7 @@ int traceroute(char *mesh_iface, int argc, char **argv)
 		dst_mac = resolve_mac(dst_string);
 
 		if (!dst_mac) {
-			printf("Error - mac address of the ping destination could not be resolved and is not a bat-host name: %s\n", dst_string);
+			fprintf(stderr, "Error - mac address of the ping destination could not be resolved and is not a bat-host name: %s\n", dst_string);
 			goto out;
 		}
 	}
@@ -114,7 +114,7 @@ int traceroute(char *mesh_iface, int argc, char **argv)
 
 	debugfs_mnt = debugfs_mount(NULL);
 	if (!debugfs_mnt) {
-		printf("Error - can't mount or find debugfs\n");
+		fprintf(stderr, "Error - can't mount or find debugfs\n");
 		goto out;
 	}
 
@@ -123,9 +123,9 @@ int traceroute(char *mesh_iface, int argc, char **argv)
 	trace_fd = open(icmp_socket, O_RDWR);
 
 	if (trace_fd < 0) {
-		printf("Error - can't open a connection to the batman adv kernel module via the socket '%s': %s\n",
+		fprintf(stderr, "Error - can't open a connection to the batman adv kernel module via the socket '%s': %s\n",
 				icmp_socket, strerror(errno));
-		printf("Check whether the module is loaded and active.\n");
+		fprintf(stderr, "Check whether the module is loaded and active.\n");
 		goto out;
 	}
 
@@ -148,7 +148,7 @@ int traceroute(char *mesh_iface, int argc, char **argv)
 			time_delta[i] = 0.0;
 
 			if (write(trace_fd, (char *)&icmp_packet_out, sizeof(icmp_packet_out)) < 0) {
-				printf("Error - can't write to batman adv kernel file '%s': %s\n", icmp_socket, strerror(errno));
+				fprintf(stderr, "Error - can't write to batman adv kernel file '%s': %s\n", icmp_socket, strerror(errno));
 				continue;
 			}
 
@@ -169,7 +169,7 @@ read_packet:
 			read_len = read(trace_fd, (char *)&icmp_packet_in, sizeof(icmp_packet_in));
 
 			if (read_len < 0) {
-				printf("Error - can't read from batman adv kernel file '%s': %s\n", icmp_socket, strerror(errno));
+				fprintf(stderr, "Error - can't read from batman adv kernel file '%s': %s\n", icmp_socket, strerror(errno));
 				continue;
 			}
 
@@ -202,9 +202,9 @@ read_packet:
 				printf("%s: Destination Host Unreachable\n", dst_string);
 				goto out;
 			case BATADV_PARAMETER_PROBLEM:
-				printf("Error - the batman adv kernel module version (%d) differs from ours (%d)\n",
+				fprintf(stderr, "Error - the batman adv kernel module version (%d) differs from ours (%d)\n",
 						icmp_packet_in.header.version, BATADV_COMPAT_VERSION);
-				printf("Please make sure to use compatible versions!\n");
+				fprintf(stderr, "Please make sure to use compatible versions!\n");
 				goto out;
 			default:
 				printf("Unknown message type %d len %zd received\n", icmp_packet_in.msg_type, read_len);
diff --git a/vis.c b/vis.c
index b040497..cc879bd 100644
--- a/vis.c
+++ b/vis.c
@@ -171,7 +171,7 @@ static FILE *open_vis(char *mesh_iface)
 
 	debugfs_mnt = debugfs_mount(NULL);
 	if (!debugfs_mnt) {
-		printf("Error - can't mount or find debugfs\n");
+		fprintf(stderr, "Error - can't mount or find debugfs\n");
 		return NULL;
 	}
 